<?php

require 'db.php';

$postdata = file_get_contents("php://input");
$request = json_decode($postdata);
if(isset($postdata) && !empty($postdata))
{
$catname = mysqli_real_escape_string($con, trim($request->catname));
$mode = mysqli_real_escape_string($con, trim($request->mode));
$subcattid = mysqli_real_escape_string($con, trim($request->subcatid));
$filesource = mysqli_real_escape_string($con, trim($request->form_value->fileSource));
$subcatname = mysqli_real_escape_string($con, trim($request->form_value->subcatname));
$starttime = mysqli_real_escape_string($con, trim($request->form_value->catstarttime));
$stoptime = mysqli_real_escape_string($con, trim($request->form_value->catstoptime));
$cattiming = mysqli_real_escape_string($con, trim($request->form_value->cattiming));

if($mode == "add")
{
    if($catname == "" || $subcatname == "" || $cattiming == null ||  $cattiming == "")
    {
        $rows = array('status'=>false,'message' => 'Fields Missing');
        echo json_encode($rows);
    }
    else
    {
        if($cattiming == 'Default')
        {
            $sel = $con->query("select start_time,end_time from setting where id='1'");
            if($row = $sel->fetch_assoc())
            {
                $starttime = $row['start_time'];
                $stoptime = $row['end_time'];
            }
        }
        if($filesource == null || $filesource == "")
        {
            $s_sql = "SELECT id FROM category WHERE catname='$catname'";
            $s_result = mysqli_query($con,$s_sql);
            if($rows = $s_result->fetch_assoc())
            {
                $catid = $rows['id'];
            }
            
            if($catid != null)
            {
                $sql = "INSERT INTO subcategory(cat_id,name,cattime,catstarttime,catstoptime,catstatus) VALUES ('$catid','$subcatname','$cattiming','$starttime','$stoptime','1')";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Sub Category Added');
                    echo json_encode($rows);
                }
            }
            else
            {
                $rows = array('status'=>false,'message' => 'No Category Available');
                echo json_encode($rows);
                
            }
        }
        else
        {
            $folderPath = "subcat/";
            $image_parts = explode(";base64,", $filesource);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type = $image_type_aux[1];
            $image_base64 = base64_decode($image_parts[1]);
            $file = $folderPath . uniqid() . '.png';
            file_put_contents($file, $image_base64);
            
            $s_sql = "SELECT id FROM category WHERE catname='$catname'";
            $s_result = mysqli_query($con,$s_sql);
            if($rows = $s_result->fetch_assoc())
            {
                $catid = $rows['id'];
            }
            
            if($catid != null)
            {
                $sql = "INSERT INTO subcategory(cat_id,name,cattime,catstarttime,catstoptime,img,catstatus) VALUES ('$catid','$subcatname','$cattiming','$starttime','$stoptime','$file','1')";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Sub Category Added');
                    echo json_encode($rows);
                }
            }
            else
            {
                $rows = array('status'=>false,'message' => 'No Category Available');
                echo json_encode($rows);
                
            }
        }
        
    }
}
else if($mode == "edit")
{
    if($catname == "" || $subcattid == "" || $subcatname == "" || $cattiming == null ||  $cattiming == "")
    {
        $rows = array('status'=>false,'message' => 'Fields Missing');
        echo json_encode($rows);
    }
    else
    {
        if($cattiming == 'Default')
        {
            $sel = $con->query("select start_time,end_time from setting where id='1'");
            if($row = $sel->fetch_assoc())
            {
                $starttime = $row['start_time'];
                $stoptime = $row['end_time'];
            }
        }
        
        if($filesource == "")
        {
            $s_sql = "SELECT id FROM category WHERE catname='$catname'";
            $s_result = mysqli_query($con,$s_sql);
            if($rows = $s_result->fetch_assoc())
            {
                $catid = $rows['id'];
            }
            
            if($catid != null && $subcattid != null)
            {
                $sql = "UPDATE subcategory set cat_id='$catid',name='$subcatname',cattime = '$cattiming',catstarttime = '$starttime',catstoptime = '$stoptime' where id='$subcattid'";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Sub Category Updated');
                    echo json_encode($rows);
                }
            }
            else
            {
                $rows = array('status'=>false,'message' => 'No Category Available');
                echo json_encode($rows);
            }
        }
        else
        {
            $folderPath = "subcat/";
            $image_parts = explode(";base64,", $filesource);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type = $image_type_aux[1];
            $image_base64 = base64_decode($image_parts[1]);
            $file = $folderPath . uniqid() . '.png';
            file_put_contents($file, $image_base64);
            
            $s_sql = "SELECT id FROM category WHERE catname='$catname'";
            $s_result = mysqli_query($con,$s_sql);
            if($rows = $s_result->fetch_assoc())
            {
                $catid = $rows['id'];
            }
            
            if($catid != null && $subcattid != null)
            {
               $sql = "UPDATE subcategory set cat_id='$catid',name='$subcatname',img='$file',cattime = '$cattiming',catstarttime = '$starttime',catstoptime = '$stoptime' where id='$subcattid'";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Sub Category Updated');
                    echo json_encode($rows);
                }
            }
            else
            {
                $rows = array('status'=>false,'message' => 'No Category Available');
                echo json_encode($rows);
                
            }
        }
    }
}
else if($mode == "delete")
{
    if($subcattid == "")
    {
        $rows = array('status'=>false,'message' => 'Sub Category Error');
        echo json_encode($rows);
    }
    else
    {
        $sql = "DELETE FROM subcategory where id ='$subcattid'";
        $result = mysqli_query($con,$sql);
        if($result)
        {
            $rows = array('status'=>true,'message' => 'Sub Category Deleted');
            echo json_encode($rows);
        }
    }
}
}
else
{
    $rows = array('status'=>false,'message' => 'Something Error');
    echo json_encode($rows);
}

?>
